import sys
from PyQt5.QtWidgets import QApplication, QMainWindow, QLabel, QPushButton, QLineEdit, QCheckBox, QProgressBar, QVBoxLayout, QWidget

class MiVentana(QMainWindow):
    def __init__(self):
        super().__init__()
        self.setWindowTitle("Mi Aplicación de Escritorio")
        self.setGeometry(100, 100, 400, 300)

        # Etiqueta
        self.label = QLabel("Escribe algo y haz clic en el botón:", self)
        self.label.setGeometry(20, 20, 300, 30)

        # Campo de texto
        self.entry = QLineEdit(self)
        self.entry.setGeometry(20, 50, 200, 30)

        # Botón
        self.button = QPushButton("Haz clic", self)
        self.button.setGeometry(230, 50, 100, 30)
        self.button.clicked.connect(self.hacer_clic)

        # Casilla de verificación
        self.checkbox = QCheckBox("Activa/Deshabilita el botón", self)
        self.checkbox.setGeometry(20, 90, 200, 30)
        self.checkbox.stateChanged.connect(self.cambiar_estado_boton)

        # Barra de progreso
        self.progress = QProgressBar(self)
        self.progress.setGeometry(20, 130, 300, 30)

        # Crear un layout vertical
        layout = QVBoxLayout()
        layout.addWidget(self.label)
        layout.addWidget(self.entry)
        layout.addWidget(self.button)
        layout.addWidget(self.checkbox)
        layout.addWidget(self.progress)

        # Crear un widget y establecer el layout en la ventana principal
        widget = QWidget()
        widget.setLayout(layout)
        self.setCentralWidget(widget)

    def hacer_clic(self):
        texto = self.entry.text()
        print("¡Haz hecho clic en el botón!")
        print("Texto ingresado:", texto)

    def cambiar_estado_boton(self, estado):
        if estado == 2:  # 2 = Checked, 0 = Unchecked
            self.button.setEnabled(False)
        else:
            self.button.setEnabled(True)

if __name__ == "__main__":
    app = QApplication(sys.argv)
    ventana = MiVentana()
    ventana.show()
    sys.exit(app.exec_())
